
#version 430

#ifdef VERTEX_SHADER

in vec3 in_position;
in vec3 in_normal;

uniform vec3 prevPos1;
uniform vec3 prevPos2;
uniform vec3 pos1;
uniform vec3 pos2;

uniform vec4 prevColor;
uniform vec4 color;

#include "shaders/lib/camera.glsl"

out vec3 vs_normal;
out vec4 vs_color;

void main() {
    vec3 worldPosition = mix(mix(prevPos2, prevPos1, in_position.z),
                             mix(pos2, pos1, in_position.z),
                             in_position.x);
    gl_Position = viewProjection * vec4(worldPosition, 1.0);

    vec3 worldNormal = vec3(0, 0, -1);
    vs_normal = (view * vec4(worldNormal, 0.0)).xyz;

    vs_color = mix(prevColor, color, in_position.x);
}

#endif

#ifdef FRAGMENT_SHADER

in vec3 vs_normal;
in vec4 vs_color;

out vec4 fragColor;
out vec3 fragNormal;

void main() {
    fragColor = vs_color;
    fragNormal = vs_normal;
}

#endif

