#version 150

#ifdef VERTEX_SHADER

in vec3 in_position;
in vec2 in_texcoord;

out vec2 texcoord;

void main() {
    gl_Position = vec4(in_position.xz * 2 - 1, 0.0, 1.0);
    texcoord = in_texcoord;
}

#endif

#ifdef FRAGMENT_SHADER

in vec2 texcoord;

out vec4 fragColor;

uniform sampler2D in_depth;
uniform float nearClip;

void main() {

    //float nonlinearDepth = texture(in_depth, texcoord).x;
    //float linearDepth = (2.0 * nearClip) / max(1.0 - nonlinearDepth, 0.0001);

    const float farClip = 100.0f;

    float nonlinearDepth = texture(in_depth, texcoord).x;
    float linearDepth = (2.0 * nearClip) / (farClip + nearClip - nonlinearDepth * (farClip - nearClip));

    fragColor = vec4(linearDepth, linearDepth, linearDepth, 1.0);
}

#endif

