#version 150

#ifdef VERTEX_SHADER

in vec3 in_position;
in vec2 in_texcoord;

out vec2 texcoord;

void main() {
    gl_Position = vec4(in_position.xz * 2 - 1, 0.0, 1.0);
    texcoord = in_texcoord;
}

#endif

#ifdef FRAGMENT_SHADER

#include "shaders/lib/camera.glsl"

in vec2 texcoord;

out vec4 fragColor;

uniform sampler2D in_normal;

void main() {
    vec3 viewNormal = texture(in_normal, texcoord).xyz;

    vec3 worldNormal = (invView * vec4(viewNormal, 0.0)).xyz;
    //fragColor = vec4(viewNormal * 0.5 + 0.5, 1.0);
    fragColor = vec4(worldNormal * 0.5 + 0.5, 1.0);
}
#endif

