#version 150

#ifdef VERTEX_SHADER

in vec3 in_position;

out vec3 texCoords;

#include "shaders/lib/camera.glsl"

void main() {
    gl_Position = viewProjection * vec4(in_position, 0.0);
    
    // OpenGL interprets the textures in a cubemap as outward facing,
    // so the image needs to be flipped horizontally to interpret the
    // textures as inward facing!
    texCoords = in_position.xyz;
}

#endif

#ifdef FRAGMENT_SHADER

in vec3 texCoords;

out vec4 fragColor;

uniform samplerCube skybox;

void main() {
    fragColor = texture(skybox, texCoords);
    //fragColor = vec4(texCoords * 0.5 + 0.5, 1);
    //fragColor = vec4(texCoords, 1);

    gl_FragDepth = 1.0f;
}

#endif

