#version 150

#ifdef VERTEX_SHADER

in vec3 in_position;

out float vs_hue;

uniform mat4 model;
uniform mat4 viewProjection;

uniform float innerRadius;
uniform float outerRadius;

void main() {
    if (gl_VertexID % 2 == 0) {
        gl_Position = viewProjection * (model * vec4(innerRadius * in_position.xy, 0, 1));
    }
    else {
        gl_Position = viewProjection * (model * vec4(outerRadius * in_position.xy, 0, 1));
    }

    vs_hue = in_position.z;
}

#endif

#ifdef FRAGMENT_SHADER

#include "shaders/lib/color.glsl"

in float vs_hue;

out vec4 fragColor;

void main() {
    vec3 rgb = HSVToRGB(vec3(vs_hue, 1, 1));
    rgb = RYBToRGB(rgb);
    fragColor = vec4(rgb, 1);
}

#endif

