#version 150

#ifdef VERTEX_SHADER

in vec3 in_position;
in vec2 in_uv;

out vec2 vs_uv;

uniform mat4 model;
uniform mat4 viewProjection;

void main() {
    gl_Position = viewProjection * (model * vec4(in_position.xzy, 1));
    vs_uv.x = in_uv.x;
    vs_uv.y = 1 - in_uv.y;
}

#endif

#ifdef FRAGMENT_SHADER

in vec2 vs_uv;

out vec4 fragColor;

uniform vec4 color;
uniform sampler2D texture0;

void main() {
    fragColor = texture(texture0, vs_uv) * color;
}

#endif

